# -*- coding: utf-8 -*-
###########################################################################

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox

from Components.ActionMap import ActionMap
from Components.Button import Button
from Components.Label import Label 

import socket
import struct
import base64

import os
import re
import shutil
import time

from Screens.ChannelSelection import service_types_tv, service_types_radio
from enigma import eServiceReference, eServiceCenter
import subprocess

# --------------------------- Logfile -------------------------------

from datetime import datetime
from shutil import copyfile
from os import remove
from os.path import isfile



########################### log file loeschen ##################################

myfile="/tmp/updateicamsettings.log"

## If file exists, delete it ##
if isfile(myfile):
    remove(myfile)
############################## File copieren ############################################
# fuer py2 die int und str anweisung raus genommen und das Grad zeichen

###########################  log file anlegen ##################################
# kitte888 logfile anlegen die eingabe in logstatus

logstatus = "on"


# ________________________________________________________________________________

def write_log(msg):
    if logstatus == ('on'):
        with open(myfile, "a") as log:

            log.write(datetime.now().strftime("%Y/%d/%m, %H:%M:%S.%f") + ": " + msg + "\n")

            return
    return

# ****************************  test ON/OFF Logfile ************************************************


def logout(data):
    if logstatus == ('on'):
        write_log(data)
        return
    return


# ----------------------------- so muss das commando aussehen , um in den file zu schreiben  ------------------------------
logout(data="start")

# Umleiten von sys.stdout auf die Log-Datei
import sys
#sys.stdout = logout




class updateicamsettings(Screen):
# bei dm image geht source key_red nicht , auch wenn man einen icon hat was nicht vorhanden ist kommt crash

    skin = """
        <screen position="center,center" size="1280,720" title="Update Icam Settings" backgroundColor="#ff000000" flags="wfNoBorder"   transparent="0" >
            
            <!-- Titel oben -->
            <eLabel name="" position="20,20" size="350,50" text="Update Icam Settings 1.0" font="Regular; 35" halign="left" backgroundColor="#00000000" foregroundColor="#00ffffff" />
            
            <!-- Balken oben -->
            <eLabel name="oben" position="0,0" size="1280,80" backgroundColor="#00000000" zPosition="-1" />
            <eLabel name="oben" position="0,80" size="1280,4" backgroundColor="#00ffffff" zPosition="0" />
                    
            
            <!-- UHR -->
            <widget render="Label" source="global.CurrentTime" position="1004,15" size="225,50" font="Regular;40" foregroundColor="#3a3998" backgroundColor="#00ffffff" halign="center" valign="center" zPosition="2">
                <convert type="ClockToText">Format:%H:%M:%S</convert>
            </widget>
           
            <!-- Hintergrung -->
            <eLabel name="mitte" position="0,84" size="1280,560" backgroundColor="#3a3998" zPosition="-1" />
            
            <!-- Balken unten -->
            <eLabel name="oben" position="0,636" size="1280,4" backgroundColor="#00ffffff" zPosition="0" />
            <eLabel name="unten" position="0,640" size="1280,80" backgroundColor="#00000000" zPosition="-1" />
            
             <!-- Info Change -->
            <eLabel position="50,150" size="900,50" foregroundColor="#00ffffff" backgroundColor="#3a3998" zPosition="2" transparent="0" font="Regular; 35" text="Sender Satellit" />
            <eLabel position="50,200" size="900,50" foregroundColor="#00ffffff" backgroundColor="#3a3998" zPosition="2" transparent="0" font="Regular; 35" text="Sender Bouquets" />
            <eLabel position="50,250" size="900,50" foregroundColor="#00ffffff" backgroundColor="#3a3998" zPosition="2" transparent="0" font="Regular; 35" text="Sender Delete" />
            <eLabel position="50,300" size="900,50" foregroundColor="#00ffffff" backgroundColor="#3a3998" zPosition="2" transparent="0" font="Regular; 35" text="Sender Change" />
            <eLabel position="50,350" size="900,50" foregroundColor="#00ffffff" backgroundColor="#3a3998" zPosition="2" transparent="0" font="Regular; 35" text="Sender New found" />
 	        <widget name="senderreferenz" font="Regular; 35" position="1000,150" size="280,50" foregroundColor="#0000ff00" backgroundColor="#3a3998" transparent="0" zPosition="3" halign="center" valign="center" />
            <widget name="senderbouquets" font="Regular; 35" position="1000,200" size="280,50" foregroundColor="#0000ff00" backgroundColor="#3a3998" transparent="0" zPosition="3" halign="center" valign="center" />
            <widget name="geloescht" font="Regular; 35" position="999,250" size="280,50" foregroundColor="#0000ff00" backgroundColor="#3a3998" transparent="0" zPosition="3" halign="center" valign="center" />
            <widget name="geaendert" font="Regular; 35" position="1000,300" size="280,50" foregroundColor="#0000ff00" backgroundColor="#3a3998" transparent="0" zPosition="3" halign="center" valign="center" />
            <widget name="neugefunden" font="Regular; 35" position="1000,350" size="280,50" foregroundColor="#0000ff00" backgroundColor="#3a3998" transparent="0" zPosition="3" halign="center" valign="center" />
	
            
            
            
              <!-- status -->
            <widget name="status" font="Regular; 50"  position="0,470" size="1280,100" foregroundColor ="#0000ff00" backgroundColor="#3a3998" transparent="0"  zPosition="3" halign="center" valign="center" />

            <!-- buttons -->
            
            <ePixmap position="50,670" zPosition="3" size="250,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/updateicamsettings/icons/red.png" transparent="1" alphatest="blend" />
            <ePixmap position="350,670" zPosition="3" size="250,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/updateicamsettings/icons/green.png"  transparent="1" alphatest="blend" />
            <ePixmap position="650,670" zPosition="3" size="250,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/updateicamsettings/icons/yellow.png"  transparent="1" alphatest="blend" />
            <ePixmap position="950,670" zPosition="3" size="250,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/updateicamsettings/icons/blue.png"  transparent="1" alphatest="blend" />
        
            
            <widget name="key_red" render="Label" position="50,660" zPosition="5" size="250,40" font="Regular;35" halign="center" valign="center" backgroundColor="#00000000" foregroundColor="#00ffffff" transparent="1"/>
            <widget name="key_green" render="Label" position="350,660" zPosition="5" size="250,40" font="Regular;35" halign="center" valign="center" backgroundColor="#00000000" foregroundColor="#00ffffff" transparent="1" />
            <widget name="key_yellow" render="Label" position="650,660" zPosition="5" size="250,40" font="Regular;35" halign="center" valign="center" backgroundColor="#00000000" foregroundColor="#00ffffff" transparent="1" />
            <widget name="key_blue" render="Label" position="950,660" zPosition="5" size="250,40" font="Regular;35" halign="center" valign="center" backgroundColor="#00000000" foregroundColor="#00ffffff" transparent="1" />
    </screen>"""








    def __init__(self, session):
        Screen.__init__(self, session)
        # hier message
        status = "press the button"
        self.status = status
        self["status"] = Label()

        senderreferenz = "0"
        self.senderreferenz = senderreferenz
        self["senderreferenz"] = Label()

        senderbouquets = "0"
        self.senderbouquets = senderbouquets
        self["senderbouquets"] = Label()

        neugefunden = "0"
        self.neugefunden = neugefunden
        self["neugefunden"] = Label()

        geloescht = "0"
        self.geloescht = geloescht
        self["geloescht"] = Label()

        geaendert = "0"
        self.geaendert = geaendert
        self["geaendert"] = Label()




        # hier die schrift auf den buttons
        #self["key_red"] = Button("red")
        self["key_green"] = Button("update")
        #self["key_yellow"] = Button("yellow")
        self["key_blue"] = Button("restore")

        self["actions"] = ActionMap(["SetupActions", "ColorActions"],
        {
            #"red": self.red,
            "green": self.green,
            "yellow": self.yellow,
            "blue": self.blue,
            "cancel": self.exit,
         }, -1)
        # hier welche def funktionen aufgerufen werden
        self["status"].setText("%s " % (self.status))
        self["senderreferenz"].setText("%s " % (self.senderreferenz))
        self["senderbouquets"].setText("%s " % (self.senderbouquets))
        self["geloescht"].setText("%s " % (self.geloescht))
        self["neugefunden"].setText("%s " % (self.neugefunden))
        self["geaendert"].setText("%s " % (self.geaendert))

    def red(self):
        return






    #  ********************************************************************************************************************
    def green(self):
        write_log("################################### start Kanalreferenz")
        self['status'].setText("Upload Kanalreferenz ")
        #time.sleep(1)
        serviceHandler = eServiceCenter.getInstance()
        refstr = '%s ORDER BY name' % (service_types_tv)

        servicelist = serviceHandler.list(eServiceReference(refstr))

        channels = servicelist and servicelist.getContent("NSR", True)
        skysender = 0
        counter = 0
        if channels is not None:
            wfile = open("/tmp/kanalref.txt", 'w')
            for channel in channels:
                orbpos = channel[2].getData(4) >> 16
                write_log("orbpos")
                write_log(str(orbpos))
                if orbpos > 1800:
                    orbpos = 3600 - orbpos
                    h = "W"
                else:
                    h = "E"
                counter += 1
                orbpos_name = ("(%d.%d" + h + ")->") % (orbpos / 10, orbpos % 10)
                write_log("orbpos_name")
                write_log(str(orbpos_name))

                write_log("serviceid")
                serviceid = channel[1].rstrip(':').replace(':', ':') + ":                      ="
                write_log(str(serviceid))
                # Wenn '8192' im Service-String enthalten ist, ersetze es durch '0'
                if '8192' in serviceid:
                    serviceid = serviceid.replace('8192', '0')

                cha = channel[0].replace('\xc2\x86', '').replace('\xc2\x87', '')
                write_log("cha")
                write_log(str(cha))

                wfile.write("%s %s\n" % (serviceid, cha))
            wfile.close()

            inputdatei = "/tmp/kanalref.txt"
            outputdatei = "/etc/enigma2/kanalrefsky.txt"

            with open(inputdatei, 'r') as infile, open(outputdatei, 'w') as outfile:
                # Durch jede Zeile in der Eingabedatei iterieren
                for line in infile:
                    # Überprüfen, ob ':85:' in der Zeile enthalten ist
                    # if ':85:' in line:
                    if ':85:' in line and not line.startswith('1:0:1:') \
                            and 'STEST1' not in line and 'STEST2' not in line and 'ALT' not in line \
                            and 'Genius' not in line and 'Zwei' not in line and 'Baden' not in line \
                            and 'ANIXE+' not in line and 'CNBC' not in line and 'REGIO' not in line and '.' not in line:
                        # Zeile in die Ausgabedatei schreiben
                        outfile.write(line)
                        skysender += 1

        refstr = '%s ORDER BY name' % (service_types_radio)
        servicelist = serviceHandler.list(eServiceReference(refstr))
        channels = servicelist and servicelist.getContent("NSR", True)
        if channels is not None:
            wfile = open("/tmp/radioref.txt", 'w')
            for channel in channels:
                orbpos = channel[2].getData(4) >> 16
                if orbpos > 1800:
                    orbpos = 3600 - orbpos
                    h = "W"
                else:
                    h = "E"
                counter += 1
                orbpos_name = ("(%d.%d" + h + ")->") % (orbpos / 10, orbpos % 10)
                serviceid = channel[1].rstrip(':').replace(':', '_') + ".png"
                cha = channel[0].replace('\xc2\x86', '').replace('\xc2\x87', '')
                wfile.write("%s %s %s\n" % (cha, orbpos_name, serviceid))
            wfile.close()
            write_log("################################### ende Kanalreferenz")
            self['status'].setText("Upload finish ")
            time.sleep(1)


# ********************************* ende Kanareferenz download mit Skyreferenz *****************************************
            self['status'].setText("Update Icam Bouquets ")
            #time.sleep(1)
            write_log("################################### start Icam Bouquets")
# **********************************************************************************************************************
            output_datei = '/etc/enigma2/nicht_gefunden.txt'  # Datei für nicht gefundene Einträge
            change_datei = "/etc/enigma2/change.txt"  # datei um geandert und geloescht zu sehen
            ## If file exists, delete it ##
            if isfile(output_datei):
                remove(output_datei)
            if isfile(change_datei):
                remove(change_datei)
            # Namen der Referenzdatei und des Verzeichnisses mit den icam-Dateien
            referenz_datei = '/etc/enigma2/kanalrefsky.txt'
            icam_verzeichnis = '/etc/enigma2/'  # Verzeichnis mit den icam-Dateien, ggf. anpassen
            # **********************************************************************************************************

            # Laden der aktuellen Einträge in ein Dictionary mit Sendernamen
            aktuelle_eintraege = {}
            with open(referenz_datei, 'r') as ref_file:
                for line in ref_file:
                    parts = line.strip().split(':')
                    if len(parts) > 5:
                        sender_id = parts[3]  # 4. Stelle (Sender-ID)
                        sender_name = parts[-1].strip()  # Annahme: Sendername steht am Ende nach einem Gleichheitszeichen
                        aktuelle_eintraege[sender_id] = {
                            "zeile": line.strip(),
                            "name": sender_name  # Speichert den Sendernamen zur späteren Überprüfung
                        }

            # Zähler für die Anzahl der http-Zeilen in den icam-Dateien
            http_zeilen_count = 0
            sendergeandert = 0
            sendergeloescht = 0
            gefundene_sender_ids = set()

            # Durch alle icam-Dateien im Verzeichnis iterieren, dabei ".old" Dateien ignorieren
            for datei_name in os.listdir(icam_verzeichnis):
                if 'icam' in datei_name and not datei_name.endswith('.old'):
                    datei_pfad = os.path.join(icam_verzeichnis, datei_name)

                    # Sicherung der Originaldatei erstellen, indem ".old" angehängt wird
                    datei_backup_pfad = datei_pfad + '.old'
                    #if not os.path.exists(datei_backup_pfad):  # sicherung muss immer erstellt werden
                    shutil.copy(datei_pfad, datei_backup_pfad)
                    #print("Sicherung erstellt: " + datei_backup_pfad)

                    with open(datei_pfad, 'r') as infile:
                        lines = infile.readlines()

                    # Liste für die aktualisierten Zeilen
                    aktualisierte_zeilen = []

                    for i, line in enumerate(lines):
                        #print(line)
                        # Verarbeitung der #SERVICE-Zeile
                        if line.startswith('#SERVICE') and 'http' in line:
                            http_zeilen_count += 1  # Zähler erhöhen, wenn eine http-Zeile gefunden wird

                            # URL-Teil extrahieren
                            service_teil, url_teil = line.strip().split('http', 1)
                            #print(service_teil)
                            #print(url_teil)

                            parts = service_teil.split(':')

                            if len(parts) > 8:
                                sender_id = parts[3]  # 4. Stelle (z.B. '7A')


                                icam_parameter1 = parts[0]  # 1. Stelle aus der icam-Datei
                                icam_parameter2 = parts[1]  # 2. Stelle aus der icam-Datei
                                icam_parameter3 = parts[2]  # 3. Stelle aus der icam-Datei
                                icam_parameter5 = parts[4]  # 5. Stelle aus der icam-Datei

                                # Prüfen, ob der Sender in den aktuellen Einträgen ist
                                if sender_id in aktuelle_eintraege:
                                    gefundene_sender_ids.add(sender_id)  # Markiere Sender als gefunden
                                    #print(sender_id)
                                    referenz_info = aktuelle_eintraege[sender_id]
                                    neue_parts = referenz_info["zeile"].split(':')

                                    neuer_parameter1 = neue_parts[0]  # Neuer Wert für die 1. Stelle
                                    neuer_parameter2 = neue_parts[1]  # Neuer Wert für die 2. Stelle
                                    neuer_parameter3 = neue_parts[2]  # Neuer Wert für die 3. Stelle
                                    neuer_parameter5 = neue_parts[4]  # Neuer Wert für die 5. Stelle

                                    # Bereinigen des Namens: Entferne führendes "=" falls vorhanden
                                    referenz_name = referenz_info["name"].lstrip('=').strip()
                                    #print("sender name referenz")
                                    #print(referenz_name)

                                    # Name am Ende der URL-Zeile überprüfen und anpassen
                                    if not url_teil.endswith(referenz_name):
                                        #url_teil = url_teil.rsplit(':', 1)[0] + f':{referenz_name}'
                                        url_teil = url_teil.rsplit(':', 1)[0] + ':{0}'.format(referenz_name)
                                        #print("neu name hat sich geandert")
                                        #print(referenz_name)
                                        #print(url_teil)
                                        sendergeandert = sendergeandert + 1

                                    #print(icam_parameter1 ,icam_parameter2 , icam_parameter3 , icam_parameter5)
                                    #print(neuer_parameter1, neuer_parameter2, neuer_parameter3, neuer_parameter5)
                                    url_teil_http = "http" + url_teil
                                    # Falls der Parameter abweicht, Zeile aktualisieren
                                    if icam_parameter5 != neuer_parameter5 or icam_parameter3 != neuer_parameter3:
                                        #new_url_teil5 = f"{url_teil_http.replace(f'%3a{icam_parameter5}', f'%3a{neuer_parameter5}')}"
                                        new_url_teil5 = "{0}".format(
                                            url_teil_http.replace('%3a{0}'.format(icam_parameter5),
                                                                  '%3a{0}'.format(neuer_parameter5)))

                                        parts[4] = neuer_parameter5  # Aktualisiere den 5. Parameter
                                        service_teil_aktualisiert = ':'.join(parts)
                                        #print (service_teil_aktualisiert)
                                        #print(new_url_teil5)

                                    #if icam_parameter3 != neuer_parameter3:
                                        #new_url_teil = f"{new_url_teil5.replace(f'%3a{icam_parameter3}', f'%3a{neuer_parameter3}')}"
                                        new_url_teil = "{0}".format(
                                            new_url_teil5.replace('%3a{0}'.format(icam_parameter3),
                                                                  '%3a{0}'.format(neuer_parameter3)))

                                        parts[2] = neuer_parameter3  # Aktualisiere den 3. Parameter
                                        service_teil_aktualisiert = ':'.join(parts)
                                        #print(service_teil_aktualisiert)
                                        #print("neu nummer hat sich geandert in dem sender")
                                        #print(referenz_name)
                                        #print(new_url_teil)

                                        sendergeandert = sendergeandert +1
                                        final_line = service_teil_aktualisiert + new_url_teil
                                        #print("neue zeile service geandert")
                                        #print(final_line)
                                        aktualisierte_zeilen.append(final_line + "\n")
                                    else:
                                        #print("zeile nichts geandert")
                                        final_line = service_teil + url_teil_http
                                        #print("neue zeile http dazu gemacht ")
                                        #print(final_line)
                                        try:
                                            # Öffne die Datei im Anhangsmodus ('a' für Append)
                                            with open(change_datei, 'a', encoding='utf-8') as datei:
                                                # Schreibe die Zeile in die Datei
                                                datei.write(final_line + '\n')

                                        except Exception as e:
                                            #print(f"Fehler beim Schreiben in die Datei: {e}")
                                            logout(data="Fehler beim schreiben nummern Execption")
                                        aktualisierte_zeilen.append(final_line + "\n")



                                    # Überprüfen und gegebenenfalls Aktualisieren der #DESCRIPTION Zeile
                                    if i + 1 < len(lines) and lines[i + 1].startswith('#DESCRIPTION'):
                                        aktuelle_beschreibung = lines[i + 1].split(' ', 1)[1].strip()


                                        # Wenn die Beschreibung anders ist, aktualisieren
                                        if aktuelle_beschreibung != referenz_name:
                                            #print("Name in Description aktuell nicht referenz")
                                            #print("Beschreibung weicht von Referenz ab , neuer name ")
                                            #print("aktuell:")
                                            #print(aktuelle_beschreibung)
                                            #print("referenz_name")
                                            #print(referenz_name)
                                            # Füge die `#SERVICE`-Zeile zur Liste der aktualisierten Zeilen hinzu
                                            #aktualisierte_zeilen.append(lines[i])
                                            aktualisierte_zeilen.append("#DESCRIPTION "+ referenz_name + "\n")
                                            #print("Beschreibung angepasst für Sender-ID" + sender_id + ":" + aktuelle_beschreibung + referenz_name)


                                        else:
                                            #print ("bouquet ist gleich referenz")
                                            aktualisierte_zeilen.append(lines[i + 1])  # Falls identisch, die alte Beschreibung übernehmen
                                    else:
                                        # Falls keine #DESCRIPTION vorhanden ist, neue hinzufügen
                                        #print("keine descrition neu dazu")
                                        aktualisierte_zeilen.append("#DESCRIPTION" + referenz_name + "\n")
                                else:
                                    #print ("++++++++++++ 1 srvid nicht gefunden ")
                                    #aktualisierte_zeilen.append(line) # nicht die zeile schreiben
                                    try:
                                        # Öffne die Datei im Anhangsmodus ('a' für Append)
                                        with open(change_datei, 'a', encoding='utf-8') as datei:
                                            # Schreibe die Zeile in die Datei
                                            datei.write(line + '\n')

                                    except Exception as e:
                                        #print(f"Fehler beim Schreiben in die Datei: {e}")
                                        logout(data="Fehler beim schreiben Execption")
                                    http_zeilen_count = http_zeilen_count - 1
                                    sendergeloescht = sendergeloescht + 1

                            else:
                                #print("+++++++++++++++++ 2")
                                aktualisierte_zeilen.append(line)
                        else:
                            #print("+++++++++++++++++ 3")
                            aktualisierte_zeilen.append(line)
                            #print(line)
                            if line.startswith('#NAME') and 'icam' in line:
                                print("NAME")
                            else:
                                if '*' in line :
                                    print("Die Zeile enthaelt einen Stern (*) Marker nicht entfernt.")
                                else:
                                    aktualisierte_zeilen.pop()  # Entferne die letzte Zeile (alte #DESCRIPTION)

                    # Datei mit den aktualisierten Zeilen überschreiben
                    with open(datei_pfad, 'w') as outfile:
                        #print("+++++++++++++++++ 4")
                        outfile.writelines(aktualisierte_zeilen)

            # Vergleich und Protokollierung der nicht gefundenen Einträge
            with open(output_datei, 'w') as out_file:
                for sender_id, referenz_info in aktuelle_eintraege.items():
                    if sender_id not in gefundene_sender_ids:
                        out_file.write(referenz_info["zeile"] + "\n")


            # nicht gefunden in neues bouquet einbauen
            #print("nicht in Bouquet vorhanden ,  neuer Sender ")
            pathNeu ="/etc/enigma2/userbouquet.skyneueicam.tv"
            neuSenderdazu = 0
            with open(output_datei, 'r') as infile:
               lines = infile.readlines()

               # Liste für die aktualisierten Zeilen
               aktualisierte_zeilen = []

               for i, line in enumerate(lines):
                   #print(line)
                   service_teil, url_name = line.strip().split('=', 1)
                   service_teil = service_teil.strip()  # Entferne Leerzeichen aus service_teil
                   url_name = url_name.strip()  # Entferne Leerzeichen aus url_name
                   #print(service_teil)
                   #print(url_name)

                   parts = service_teil.split(':')

                   para1 = parts[0]  # 1. Stelle aus der icam-Datei
                   para2 = parts[1]  # 2. Stelle aus der icam-Datei
                   para3 = parts[2]  # 3. Stelle aus der icam-Datei
                   para4 = parts[3]  # 4. Stelle aus der icam-Datei
                   para5 = parts[4]  # 5. Stelle aus der icam-Datei
                   para6 = parts[5]  # 6. Stelle aus der icam-Datei

                   #neueSender = f"#SERVICE {para1}:{para2}:{para3}:{para4}:{para5}:{para6}:21:0:0:0:http%3a//127.0.0.1%3a17999/{para1}%3a{para2}%3a{para3}%3a{para4}%3a{para5}%3a{para6}%3aC00000%3a0%3a0%3a0%3a:{url_name}"
                   neueSender = "#SERVICE {0}:{1}:{2}:{3}:{4}:{5}:21:0:0:0:http%3a//127.0.0.1%3a17999/{0}%3a{1}%3a{2}%3a{3}%3a{4}%3a{5}%3aC00000%3a0%3a0%3a0%3a:{6}".format(
                       para1, para2, para3, para4, para5, para6, url_name
                   )
                   #print("neue Zeile")
                   #print(neueSender)
                   neueDescription ="#DESCRIPTION" + url_name
                   neueName ="#NAME SKY Neue Sender icam"
                   # Füge die neue Zeile zur Liste hinzu
                   aktualisierte_zeilen.append(neueSender + "\n")  # Füge einen Zeilenumbruch hinzu
                   aktualisierte_zeilen.append(neueDescription + "\n")
                   http_zeilen_count = http_zeilen_count + 1
                   neuSenderdazu = neuSenderdazu + 1
               # Schreibe die aktualisierten Zeilen in die neue Datei
            with open(pathNeu, 'a') as outfile:
                outfile.writelines(aktualisierte_zeilen)
            #print("Die Datei wurde erfolgreich in" + pathNeu + "geschrieben.")

            #print()
            # Ausgabe der Zähler
            ##print("Anzahl der Sender in der Referenzdatei        :" + len(aktuelle_eintraege))
            #print("Anzahl der Sender in den Bouquets icam-Dateien:" + http_zeilen_count)
            #print("neu Sky Sender geaendert                      :" + sendergeandert)
            #print("neu Sky Sender gefunden                       :" + neuSenderdazu)
            #print("neu Sky Sender geloescht                      :" + sendergeloescht)
            #print()
            #print("Nicht gefundene Einträge wurden in" + output_datei + " gespeichert.")
            #print("Aktualisierung der icam-Dateien abgeschlossen.")
            self["senderreferenz"].setText("%s " % (len(aktuelle_eintraege)))
            self["senderbouquets"].setText("%s " % (http_zeilen_count))
            self["geloescht"].setText("%s " % (sendergeloescht))
            self["neugefunden"].setText("%s " % (neuSenderdazu))
            self["geaendert"].setText("%s " % (sendergeandert))
# *********************************************************************************************************
            # Aufruf der Funktion
            reload_settings()


# **********************************************************************************************************************
    def yellow(self):
        reload_settings()
        #self['status'].setText(self.reloaderror)
        #return

# *********************************************************************************************************
    def blue(self):

        write_log("################################### restore start")
        # Pfad zum Ordner, in dem die Dateien liegen
        pfad = "/etc/enigma2/"

        # Alle Dateien im Ordner durchgehen
        for datei in os.listdir(pfad):
            # Wenn die Datei mit .old endet
            if datei.endswith(".old"):
                # Ursprünglicher und neuer Dateiname
                alter_name = os.path.join(pfad, datei)
                neuer_name = os.path.join(pfad, datei.replace(".old", ""))

                # Datei umbenennen (zurückkopieren ohne .old)
                os.rename(alter_name, neuer_name)
                write_log("################################### restore ende")
                self['status'].setText("Restore Icam Bouquets finish ")
# *********************************************************************************************************************

    def exit(self):
        self.close()


import requests
import time


def reload_settings():
    logout(data="start reload settings")
    url = "http://root:box@127.0.0.1/web/servicelistreload?mode=0"

    try:
        logout(data="try")
        response = requests.get(url, timeout=5)

        if response.status_code == 200:
            logout(data="Settings erfolgreich neu geladen")
            #print("Settings erfolgreich neu geladen.")
        else:
            logout(data="Fehler beim Reload")
            #print("Fehler beim Reload: " + response.status_code + "-" + response.text)

        time.sleep(2)  # 2 Sekunden Pause

    except Exception as e:
        logout(data="Fehler beim Reload Execption")
        logout(data=f"Fehler beim Reload Exception: {str(e)}")
        reloaderror="test"
        #self.reloaderror=reloaderror


#  ********************************************************************************************************************

# **********************************************************************************************************************

def main(session, **kwargs):
        session.open(updateicamsettings)

def Plugins(**kwargs):

        return [
                PluginDescriptor(name="updateicamsettings", description="Update Icam Settings ", where = PluginDescriptor.WHERE_PLUGINMENU, icon="plugin.png", fnc=main)
                ]
